<?php

global $user, $lang, $conf, $template, $errors;

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include(get_language_filepath('plugin.lang.php', NBC_LinkUser2PunBB_PATH));

include_once (PHPWG_ROOT_PATH.'/include/constants.php');
include_once (NBC_LinkUser2PunBB_PATH.'include/constants.php');
include_once (NBC_LinkUser2PunBB_PATH.'include/functions_LinkUser2PunBB.inc.php');






function Audit_PWG_PunBB()
{
  global $page, $conf, $errors;

  $conf_nbc_LinkUser2PunBB = isset($conf['nbc_LinkUser2PunBB']) ? explode(";" , $conf['nbc_LinkUser2PunBB']) : array();

  $page_LinkUser2PunBB_admin = get_admin_plugin_menu_link(__FILE__);
  


  $msg_error_PWG_Dup = '';
  $msg_error_PunBB_Dup = '';
  $msg_error_Link_Break = '';
  $msg_error_Link_Bad = '';
  $msg_error_Synchro = '';
  $msg_ok_Synchro = '';
  $msg_error_PWG2PunBB = '';
  $msg_error_PunBB2PWG = '';



  $query = "
    SELECT COUNT(*) AS nbr_dup, id, username
    FROM ".USERS_TABLE." 
    GROUP BY BINARY username
    HAVING COUNT(*) > 1
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
    $msg_error_PWG_Dup .= '<br/>'.l10n('LinkUser2PunBB_Error_PWG_Dup').$row['nbr_dup'].' x '.$row['username'];

  if ($msg_error_PWG_Dup == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_PWG_Dup').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_PWG_Dup = l10n('LinkUser2PunBB_Audit_PWG_Dup').$msg_error_PWG_Dup.'<br>'.l10n('LinkUser2PunBB_Advise_PWG_Dup');
  


  $query = "
    SELECT COUNT(*) AS nbr_dup, username
    FROM ".PUNBB_USERS_TABLE." 
    GROUP BY BINARY username
    HAVING COUNT(*) > 1
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    $msg_error_PunBB_Dup .= '<br/>'.l10n('LinkUser2PunBB_Error_PunBB_Dup').$row['nbr_dup'].' x '.$row['username'];

    $subquery = "
      SELECT id, username, email
      FROM ".PUNBB_USERS_TABLE." 
      WHERE BINARY username = BINARY '".$row['username']."'
    ;";
    $subresult = pwg_query($subquery);
  
    while($subrow = mysql_fetch_array($subresult))
    {
      $msg_error_PunBB_Dup .= '<br/>id:'.$subrow['id'].'='.$subrow['username'].' ('.$subrow['email'].')';
  
      if ( !is_adviser() )
      {
        $msg_error_PunBB_Dup .= ' <a href="';
      
        $msg_error_PunBB_Dup .= add_url_params($page_LinkUser2PunBB_admin, array(
          'action' => 'del_user',
          'id' => $subrow['id'],
        ));
        $msg_error_PunBB_Dup .= '" title="'.l10n('LinkUser2PunBB_Del_User').$subrow['username'].'"';
        $msg_error_PunBB_Dup .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
        $msg_error_PunBB_Dup .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_delete.png" alt="'.l10n('LinkUser2PunBB_Del_User').$subrow['username'].'" /></a>';
      }
    }
  }

  if ($msg_error_PunBB_Dup == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_PunBB_Dup').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_PunBB_Dup = l10n('LinkUser2PunBB_Audit_PunBB_Dup').$msg_error_PunBB_Dup.'<br>'.l10n('LinkUser2PunBB_Advise_PunBB_Dup');
  


  $query = "
    SELECT pwg.id as pwg_id, bb.id as bb_id, pwg.username as pwg_user, pwg.mail_address as pwg_mail
    FROM ".PUNBB_USERS_TABLE." AS bb, ".USERS_TABLE." as pwg
    WHERE bb.id NOT in (
      SELECT id_user_PunBB
      FROM ".LinkUser2PunBB_ID_TABLE."
    )
    AND pwg.id NOT in (
      SELECT id_user_pwg
      FROM ".LinkUser2PunBB_ID_TABLE."
    )
    AND pwg.username = bb.username
    AND pwg.mail_address = bb.email
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    $msg_error_Link_Break .= '<br/>'.l10n('LinkUser2PunBB_Error_Link_Break').$row['pwg_user'].' ('.$row['pwg_mail'].')';

    if ( !is_adviser() )
    {
      $msg_error_Link_Break .= ' <a href="';
  
      $msg_error_Link_Break .= add_url_params($page_LinkUser2PunBB_admin, array(
        'action'   => 'new_link',
        'pwg_id' => $row['pwg_id'],
        'bb_id' => $row['bb_id'],
      ));
      $msg_error_Link_Break .= '" title="'.l10n('LinkUser2PunBB_New_Link').$row['pwg_user'].'"';
      $msg_error_Link_Break .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_Link_Break .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/link_break.png" alt="'.l10n('LinkUser2PunBB_New_Link').$row['pwg_user'].'" /></a>';
    }
  }

  if ($msg_error_Link_Break == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_Link_Break').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_Link_Break = l10n('LinkUser2PunBB_Audit_Link_Break').$msg_error_Link_Break;
    

  
  $query = "
    SELECT pwg.username as pwg_user, pwg.id as pwg_id, pwg.mail_address as pwg_mail, bb.id as bb_id, bb.username as bb_user, bb.email as bb_mail
    FROM ".PUNBB_USERS_TABLE." AS bb 
    INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = bb.id
  	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
    WHERE pwg.username <> bb.username
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Error_Link_Del').$row['pwg_user'].' ('.$row['pwg_mail'].')'.' -- '.$row['bb_user'].' ('.$row['bb_mail'].')';

    if ( !is_adviser() )
    {
      $msg_error_Link_Bad .= ' <a href="';
  
      $msg_error_Link_Bad .= add_url_params($page_LinkUser2PunBB_admin, array(
        'action'   => 'link_del',
        'pwg_id' => $row['pwg_id'],
        'bb_id'  => $row['bb_id'],
      ));
      $msg_error_Link_Bad .= '" title="'.l10n('LinkUser2PunBB_Link_Del').$row['pwg_user'].' -- '.$row['bb_user'].'"';
      $msg_error_Link_Bad .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_Link_Bad .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/link_delete.png" alt="'.l10n('LinkUser2PunBB_Link_Del').$row['pwg_user'].' -- '.$row['bb_user'].'" /></a>';
    }
  }


  $query = "
    SELECT COUNT(*) as nbr_dead
    FROM ".LinkUser2PunBB_ID_TABLE." AS Link
    WHERE id_user_PunBB NOT IN (
      SELECT id
      FROM ".PUNBB_USERS_TABLE."
    )
    OR id_user_pwg NOT IN (
      SELECT id
      FROM ".USERS_TABLE."
    )
  ;";
  $Compteur = mysql_fetch_array(pwg_query($query));

  if ( !empty($Compteur) and $Compteur['nbr_dead'] > 0)
  { 
    $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Error_Link_Dead').$Compteur['nbr_dead'];

    if ( !is_adviser() )
    {
      $msg_error_Link_Bad .= ' <a href="';
  
      $msg_error_Link_Bad .= add_url_params($page_LinkUser2PunBB_admin, array(
      'action'   => 'link_dead',
      ));
      $msg_error_Link_Bad .= '" title="'.l10n('LinkUser2PunBB_Link_Dead').$Compteur['nbr_dead'].'"';
      $msg_error_Link_Bad .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_Link_Bad .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/link_delete.png" alt="'.l10n('LinkUser2PunBB_Link_Dead').$Compteur['nbr_dead'].'" /></a>';
    }
  }

  $query = "
    SELECT COUNT(*) AS nbr_dup, pwg.id AS pwg_id, pwg.username AS pwg_user, bb.username AS bb_user, bb.id AS bb_id
    FROM ".PUNBB_USERS_TABLE." AS bb 
    INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = bb.id
  	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
    GROUP BY link.id_user_pwg, link.id_user_PunBB
    HAVING COUNT(*) > 1
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Error_Link_Dup').$row['nbr_dup'].' = '.$row['pwg_user'].' -- '.$row['bb_user'].')';

    if ( !is_adviser() )
    {
      $msg_error_Link_Bad .= ' <a href="';

      $msg_error_Link_Bad .= add_url_params($page_LinkUser2PunBB_admin, array(
        'action'   => 'new_link',
        'pwg_id' => $row['pwg_id'],
        'bb_id' => $row['bb_id'],
      ));
      $msg_error_Link_Bad .= '" title="'.l10n('LinkUser2PunBB_Link_Dup').$row['pwg_user'].' -- '.$row['bb_user'].'"';
      $msg_error_Link_Bad .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_Link_Bad .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/link_error.png" alt="'.l10n('LinkUser2PunBB_Link_Dup').$row['pwg_user'].' -- '.$row['bb_user'].'" /></a>';
    }      
  }

  if ($msg_error_Link_Bad == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_Link_Bad').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_Link_Bad = l10n('LinkUser2PunBB_Audit_Link_Bad').$msg_error_Link_Bad;
    

  
  $query = "
    SELECT pwg.username as username, pwg.password as pwg_pwd, pwg.mail_address as pwg_eml, PunBB.password as bb_pwd, PunBB.email as bb_eml
    FROM ".PUNBB_USERS_TABLE." AS PunBB 
    INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = PunBB.id
  	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
  	AND BINARY pwg.username = BINARY PunBB.username
  	ORDER BY LOWER(pwg.username)
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    if ( ($row['pwg_pwd'] != $row['bb_pwd']) or ($row['pwg_eml'] != $row['bb_eml']) )
    {
      $msg_error_Synchro .= '<br/>'.l10n('LinkUser2PunBB_Error_Synchro').$row['username'];

      if ( !is_adviser() )
      {
        $msg_error_Synchro .= ' <a href="';
  
        $msg_error_Synchro .= add_url_params($page_LinkUser2PunBB_admin, array(
          'action' => 'sync_user',
          'username' => $row['username'],
        ));
        $msg_error_Synchro .= '" title="'.l10n('LinkUser2PunBB_Sync_User').$row['username'].'"';
        $msg_error_Synchro .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
        $msg_error_Synchro .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_refresh.png" alt="'.l10n('LinkUser2PunBB_Sync_User').$row['username'].'" /></a>';
      }
      
      if ($row['pwg_pwd'] != $row['bb_pwd'])
        $msg_error_Synchro .= '<br>'.l10n('LinkUser2PunBB_Error_Synchro_Pswd');
      
      if ($row['pwg_eml'] != $row['bb_eml'])
        $msg_error_Synchro .= '<br>'.l10n('LinkUser2PunBB_Error_Synchro_Mail').'<br/>-- PWG = '.$row['pwg_eml'].'<br/>-- PunBB = '.$row['bb_eml'];
    }
    else
      $msg_ok_Synchro .= '<br/>'.$row['username'].' ('.$row['pwg_eml'].')'.l10n('LinkUser2PunBB_Audit_Synchro_OK');
  }

  if ($msg_error_Synchro <> '')
    $msg_error_Synchro = l10n('LinkUser2PunBB_Audit_Synchro').$msg_error_Synchro;
    
  if ($msg_ok_Synchro <> '')
    if ($msg_error_Synchro <> '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Audit_Synchro').$msg_ok_Synchro.'<br/><br/>');
    else
      array_push($page['infos'], l10n('LinkUser2PunBB_Audit_Synchro').$msg_ok_Synchro.'<br/><br/>'.l10n('LinkUser2PunBB_Audit_OK'));


  $query = "
    SELECT username, mail_address FROM ".USERS_TABLE."
    WHERE BINARY username <> BINARY 'guest'
    AND id not in (
      SELECT id_user_pwg FROM ".LinkUser2PunBB_ID_TABLE."
    )
    AND BINARY username not in (
      SELECT username FROM ".PUNBB_USERS_TABLE."
    )
   	ORDER BY LOWER(username)
  ;";
  $result = pwg_query($query);

  while($row = mysql_fetch_array($result))
  {
    $msg_error_PWG2PunBB .= '<br/>'.l10n('LinkUser2PunBB_Error_PWG2PunBB').$row['username'].' ('.$row['mail_address'].')';

    if ( !is_adviser() )
    {
      $msg_error_PWG2PunBB .= ' <a href="';

      $msg_error_PWG2PunBB .= add_url_params($page_LinkUser2PunBB_admin, array(
        'action' => 'add_user',
        'username' => $row['username'],
      ));
      $msg_error_PWG2PunBB .= '" title="'.l10n('LinkUser2PunBB_Add_User').$row['username'].'" ';
      $msg_error_PWG2PunBB .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_PWG2PunBB .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_add.png" alt="'.l10n('LinkUser2PunBB_Add_User').$row['username'].'" /></a>';
    }
  }

  if ($msg_error_PWG2PunBB == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_PWG2PunBB').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_PWG2PunBB = l10n('LinkUser2PunBB_Audit_PWG2PunBB').$msg_error_PWG2PunBB;

  

  $query = "
    SELECT id, username, email FROM ".PUNBB_USERS_TABLE."
    WHERE BINARY username <> BINARY '".$conf_nbc_LinkUser2PunBB[2]."'
    AND id not in (
      SELECT id_user_PunBB FROM ".LinkUser2PunBB_ID_TABLE."
    )
    AND BINARY username not in (
      SELECT username FROM ".USERS_TABLE."
    )
   	ORDER BY LOWER(username)
  ;";
  $result = pwg_query($query);

  while($row = mysql_fetch_array($result))
  {
    $msg_error_PunBB2PWG .= '<br/>'.l10n('LinkUser2PunBB_Error_PunBB2PWG').$row['username'].' ('.$row['email'].')';

    if ( !is_adviser() )
    {
      $msg_error_PunBB2PWG .= ' <a href="';
    
      $msg_error_PunBB2PWG .= add_url_params($page_LinkUser2PunBB_admin, array(
        'action' => 'del_user',
        'id' => $row['id'],
      ));
      $msg_error_PunBB2PWG .= '" title="'.l10n('LinkUser2PunBB_Del_User').$row['username'].'"';
      $msg_error_PunBB2PWG .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
      $msg_error_PunBB2PWG .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_delete.png" alt="'.l10n('LinkUser2PunBB_Del_User').$row['username'].'" /></a>';
    }
  }

  if ($msg_error_PunBB2PWG == '')
    array_push($page['infos'], l10n('LinkUser2PunBB_Audit_PunBB2PWG').'<br/>'.l10n('LinkUser2PunBB_Audit_OK'));
  else
    $msg_error_PunBB2PWG = l10n('LinkUser2PunBB_Audit_PunBB2PWG').$msg_error_PunBB2PWG;



  if ($msg_error_PWG_Dup <> '')
    $errors[] = $msg_error_PWG_Dup . ( ($msg_error_PunBB_Dup == '' and $msg_error_Link_Break == '' and $msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );
  
  if ($msg_error_PunBB_Dup <> '')
    $errors[] = $msg_error_PunBB_Dup . ( ($msg_error_Link_Break == '' and $msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Link_Break <> '')
    $errors[] = $msg_error_Link_Break . ( ($msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Link_Bad <> '')
    $errors[] = $msg_error_Link_Bad . ( ($msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Synchro <> '')
    $errors[] = $msg_error_Synchro . ( ($msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_PWG2PunBB <> '')
    $errors[] = $msg_error_PWG2PunBB . ( ($msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_PunBB2PWG <> '')
    $errors[] = $msg_error_PunBB2PWG;
}






if ( isset($_GET['action']) and ($_GET['action']=='link_dead') and !is_adviser() )
{
  $query = "
		DELETE FROM ".LinkUser2PunBB_ID_TABLE."
    WHERE id_user_PunBB NOT IN (
      SELECT id
      FROM ".PUNBB_USERS_TABLE."
    )
    OR id_user_pwg NOT IN (
      SELECT id
      FROM ".USERS_TABLE."
    )
  ;";
  $result = pwg_query($query);
  
  Audit_PWG_PunBB();
}
else if ( isset($_GET['action']) and ($_GET['action']=='link_del') and isset($_GET['pwg_id']) and isset($_GET['bb_id']) and !is_adviser() )
{
  $query = "
		DELETE FROM ".LinkUser2PunBB_ID_TABLE."
		WHERE id_user_pwg = ".$_GET['pwg_id']."
		AND id_user_PunBB = ".$_GET['bb_id']."
  ;";
  $result = pwg_query($query);
  
  Audit_PWG_PunBB();
}
else if ( isset($_GET['action']) and ($_GET['action']=='new_link') and isset($_GET['pwg_id']) and isset($_GET['bb_id']) and !is_adviser() )
{
  PunBB_Linkuser($_GET['pwg_id'], $_GET['bb_id']);
  
  Audit_PWG_PunBB();
}
else if ( isset($_GET['action']) and ($_GET['action']=='sync_user') and isset($_GET['username']) and !is_adviser() )
{
  $query = "
    SELECT id AS id_pwg, password, mail_address 
  	FROM ".USERS_TABLE."
  	WHERE BINARY username = BINARY '".$_GET['username']."'
  	LIMIT 1
  ;";
  $data = mysql_fetch_array(pwg_query($query));
  
  if (!empty($data))
  {
    PunBB_Updateuser($data['id_pwg'], $data['password'], $data['mail_address']);
  }
  
  Audit_PWG_PunBB();
}
else if ( isset($_GET['action']) and ($_GET['action']=='add_user') and isset($_GET['username']) and !is_adviser() )
{
  $query = "
    SELECT id, username, password, mail_address 
  	FROM ".USERS_TABLE."
  	WHERE BINARY username = BINARY '".$_GET['username']."'
  	LIMIT 1
  ;";
  $data = mysql_fetch_array(pwg_query($query));
  
  if (!empty($data))
    PunBB_Adduser($data['id'], $data['username'], $data['password'], $data['mail_address']);  
  
  Audit_PWG_PunBB();
}
else if ( isset($_GET['action']) and ($_GET['action']=='del_user') and isset($_GET['id']) and !is_adviser() )
{
  PunBB_Deluser( $_GET['id'], true );
  
  Audit_PWG_PunBB();
}






if ( isset($_POST['submit']) and !is_adviser() and isset($_POST['PunBB_prefix']) and isset($_POST['PunBB_admin']) 
  and isset($_POST['PunBB_guest']) and isset($_POST['PunBB_del_pt']) and isset($_POST['PunBB_Confirm']) )
{
  $conf['nbc_LinkUser2PunBB'] = $_POST['PunBB_prefix'].';'.$_POST['PunBB_admin'].';'.$_POST['PunBB_guest'].';'.$_POST['PunBB_del_pt'].';'.$_POST['PunBB_Confirm'];

  $query = '
    UPDATE '.CONFIG_TABLE.'
    SET value="'.$conf['nbc_LinkUser2PunBB'].'"
    WHERE param="nbc_LinkUser2PunBB"
    LIMIT 1
  ;';
  pwg_query($query);

  array_push($page['infos'], l10n('LinkUser2PunBB_save_config'));
}
else if ( isset($_POST['Migration']) and !is_adviser() )
{
  array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Start'));
  
  
  array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Del_Link'));

  $query = "TRUNCATE ".LinkUser2PunBB_ID_TABLE.";";
  $result = pwg_query($query);
  
  
  array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Del_AllUsers'));

  $query = "
    SELECT username, id
    FROM ".PUNBB_USERS_TABLE."
  ;";
  $result = pwg_query($query);
  
  while ($row = mysql_fetch_array($result))
  {
    if(($row['username'] != $conf_nbc_LinkUser2PunBB[2]) AND ($row['username'] != $conf_nbc_LinkUser2PunBB[1]) )
    {
      array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Del_User').$row['username']);
        
      PunBB_Deluser($row['id'], false);
    }
  }


  array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Add_AllUsers'));

  $query = "
    SELECT id, username, password, mail_address
    FROM ".USERS_TABLE."
  ;";
  $result = pwg_query($query);
  
  $registred = time();
  $registred_ip = $_SERVER['REMOTE_ADDR'];
  
  while ($row = mysql_fetch_array($result))
  {
    if(($row['username'] != 'guest') AND ($row['username'] != $conf_nbc_LinkUser2PunBB[1]) )
    {
      array_push($page['infos'], l10n('LinkUser2PunBB_Mig_Add_User').$row['username']);

      PunBB_Adduser($row['id'], $row['username'], $row['password'], $row['mail_address']);
    }
  }


  array_push($page['infos'], l10n('LinkUser2PunBB_Mig_End'));
}
else if ( isset($_POST['Synchro']) and !is_adviser() )
{
  global $page,$conf, $errors;

  $conf_nbc_LinkUser2PunBB = isset($conf['nbc_LinkUser2PunBB']) ? explode(";" , $conf['nbc_LinkUser2PunBB']) : array();

  $page_LinkUser2PunBB_admin = get_admin_plugin_menu_link(__FILE__);
  


  $msg_error_PWG_Dup = '';
  $msg_error_PunBB_Dup = '';
  $msg_error_Link_Break = '';
  $msg_error_Link_Bad = '';
  $msg_error_Synchro = '';
  $msg_ok_Synchro = '';
  $msg_error_PunBB2PWG = '';
  $msg_error_PWG2PunBB = '';



  $query = "
    SELECT COUNT(*) AS nbr_dup, id, username
    FROM ".USERS_TABLE." 
    GROUP BY BINARY username
    HAVING COUNT(*) > 1
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
    $msg_error_PWG_Dup .= '<br/>'.l10n('LinkUser2PunBB_Error_PWG_Dup').$row['nbr_dup'].' x '.$row['username'];

  if ($msg_error_PWG_Dup <> '')
    $msg_error_PWG_Dup = l10n('LinkUser2PunBB_Audit_PWG_Dup').$msg_error_PWG_Dup.'<br>'.l10n('LinkUser2PunBB_Advise_PWG_Dup');
  


  $query = "
    SELECT COUNT(*) AS nbr_dup, username
    FROM ".PUNBB_USERS_TABLE." 
    GROUP BY BINARY username
    HAVING COUNT(*) > 1
  ;";
  $result = pwg_query($query);
  
  while($row = mysql_fetch_array($result))
  {
    $msg_error_PunBB_Dup .= '<br/>'.l10n('LinkUser2PunBB_Error_PunBB_Dup').$row['nbr_dup'].' x '.$row['username'];

    $subquery = "
      SELECT id, username, email
      FROM ".PUNBB_USERS_TABLE." 
      WHERE BINARY username = BINARY '".$row['username']."'
    ;";
    $subresult = pwg_query($subquery);
  
    while($subrow = mysql_fetch_array($subresult))
    {
      $msg_error_PunBB_Dup .= '<br/>id:'.$subrow['id'].'='.$subrow['username'].' ('.$subrow['email'].')';
  
      if ( !is_adviser() )
      {
        $msg_error_PunBB_Dup .= ' <a href="';
      
        $msg_error_PunBB_Dup .= add_url_params($page_LinkUser2PunBB_admin, array(
          'action' => 'del_user',
          'id' => $subrow['id'],
        ));
        $msg_error_PunBB_Dup .= '" title="'.l10n('LinkUser2PunBB_Del_User').$subrow['username'].'"';
        $msg_error_PunBB_Dup .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
        $msg_error_PunBB_Dup .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_delete.png" alt="'.l10n('LinkUser2PunBB_Del_User').$subrow['username'].'" /></a>';
      }
    }
  }

  if ($msg_error_PunBB_Dup <> '')
    $msg_error_PunBB_Dup = l10n('LinkUser2PunBB_Sync_Check_Dup').$msg_error_PunBB_Dup.'<br>'.l10n('LinkUser2PunBB_Advise_PunBB_Dup');

  

  if ($msg_error_PunBB_Dup == '' and $msg_error_PWG_Dup == '')
  {
    $query = "
      SELECT pwg.id as pwg_id, bb.id as bb_id, pwg.username as pwg_user, pwg.mail_address as pwg_mail
      FROM ".PUNBB_USERS_TABLE." AS bb, ".USERS_TABLE." as pwg
      WHERE bb.id NOT in (
        SELECT id_user_PunBB
        FROM ".LinkUser2PunBB_ID_TABLE."
      )
      AND pwg.id NOT in (
        SELECT id_user_pwg
        FROM ".LinkUser2PunBB_ID_TABLE."
      )
      AND pwg.username = bb.username
      AND pwg.mail_address = bb.email
    ;";
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array($result))
    {
      $msg_error_Link_Break .= '<br/>'.l10n('LinkUser2PunBB_New_Link').$row['pwg_user'].' ('.$row['pwg_mail'].')';
  
      PunBB_Linkuser($row['pwg_id'], $row['bb_id']);
    }
  
    if ($msg_error_Link_Break == '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Sync_Link_Break').'<br/>'.l10n('LinkUser2PunBB_Sync_OK'));
    else
      $msg_error_Link_Break = l10n('LinkUser2PunBB_Sync_Link_Break').$msg_error_Link_Break;

  
    
    $query = "
      SELECT pwg.username as pwg_user, pwg.id as pwg_id, pwg.mail_address as pwg_mail, bb.id as bb_id, bb.username as bb_user, bb.email as bb_mail
      FROM ".PUNBB_USERS_TABLE." AS bb 
      INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = bb.id
    	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
      WHERE BINARY pwg.username <> BINARY bb.username
    ;";
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array($result))
    {
      $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Link_Del').$row['pwg_user'].' ('.$row['pwg_mail'].')'.' -- '.$row['bb_user'].' ('.$row['bb_mail'].')';

      $subquery = "
    		DELETE FROM ".LinkUser2PunBB_ID_TABLE."
    		WHERE id_user_pwg = ".$row['pwg_id']."
    		AND id_user_PunBB = ".$row['bb_id']."
      ;";
      $subresult = pwg_query($subquery);
    }


    $query = "
      SELECT COUNT(*) as nbr_dead
      FROM ".LinkUser2PunBB_ID_TABLE." AS Link
      WHERE id_user_PunBB NOT IN (
        SELECT id
        FROM ".PUNBB_USERS_TABLE."
      )
      OR id_user_pwg NOT IN (
        SELECT id
        FROM ".USERS_TABLE."
      )
    ;";
    $Compteur = mysql_fetch_array(pwg_query($query));
    
    if ( !empty($Compteur) and $Compteur['nbr_dead'] > 0)
    { 
      $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Link_Dead').$Compteur['nbr_dead'];
    
      $query = "
    		DELETE FROM ".LinkUser2PunBB_ID_TABLE."
        WHERE id_user_PunBB NOT IN (
          SELECT id
          FROM ".PUNBB_USERS_TABLE."
        )
        OR id_user_pwg NOT IN (
          SELECT id
          FROM ".USERS_TABLE."
        )
      ;";
      $result = pwg_query($query);
    }
    
      
    $query = "
      SELECT COUNT(*) AS nbr_dup, pwg.id AS pwg_id, pwg.username AS pwg_user, bb.username AS bb_user, bb.id AS bb_id
      FROM ".PUNBB_USERS_TABLE." AS bb 
      INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = bb.id
    	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
      GROUP BY link.id_user_pwg, link.id_user_PunBB
      HAVING COUNT(*) > 1
    ;";
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array($result))
    {
      $msg_error_Link_Bad .= '<br/>'.l10n('LinkUser2PunBB_Link_Dup').$row['nbr_dup'].' = '.$row['pwg_user'].' -- '.$row['bb_user'].')';
  
      PunBB_Linkuser($row['pwg_id'], $row['bb_id']);
    }

    if ($msg_error_Link_Bad == '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Sync_Link_Bad').'<br/>'.l10n('LinkUser2PunBB_Sync_OK'));
    else
      $msg_error_Link_Bad = l10n('LinkUser2PunBB_Sync_Link_Bad').$msg_error_Link_Bad;
      
  
    
    $query = "
      SELECT pwg.id as pwg_id, pwg.username as username, pwg.password as pwg_pwd, pwg.mail_address as pwg_eml, PunBB.id as bb_id, PunBB.password as bb_pwd, PunBB.email as bb_eml
      FROM ".PUNBB_USERS_TABLE." AS PunBB 
      INNER JOIN ".LinkUser2PunBB_ID_TABLE." AS link ON link.id_user_PunBB = PunBB.id
    	INNER JOIN ".USERS_TABLE." as pwg ON link.id_user_pwg = pwg.id
    	AND BINARY pwg.username = BINARY PunBB.username
    	ORDER BY LOWER(pwg.username)
    ;";
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array($result))
    {
      if ( ($row['pwg_pwd'] != $row['bb_pwd']) or ($row['pwg_eml'] != $row['bb_eml']) )
      {
        $msg_error_Synchro .= '<br/>'.l10n('LinkUser2PunBB_Sync_User').$row['username'];
  
        $query = "
          SELECT id, password, mail_address 
        	FROM ".USERS_TABLE."
        	WHERE BINARY id = '".$row['pwg_id']."'
        ;";
        $data = mysql_fetch_array(pwg_query($query));
        
        if (!empty($data))
          PunBB_Updateuser($data['id'], $data['password'], $data['mail_address']);
      }
    }
  
    if ($msg_error_Synchro == '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Sync_DataUser').'<br/>'.l10n('LinkUser2PunBB_Sync_OK'));
    else
      $msg_error_Synchro = l10n('LinkUser2PunBB_Sync_DataUser').$msg_error_Synchro;

  
  
    $query = "
      SELECT username, mail_address FROM ".USERS_TABLE."
      WHERE BINARY username <> BINARY 'guest'
      AND id not in (
        SELECT id_user_pwg FROM ".LinkUser2PunBB_ID_TABLE."
      )
      AND BINARY username not in (
        SELECT username FROM ".PUNBB_USERS_TABLE."
      )
     	ORDER BY LOWER(username)
    ;";
    $result = pwg_query($query);
  
    while($row = mysql_fetch_array($result))
    {
      $msg_error_PWG2PunBB .= '<br/>'.l10n('LinkUser2PunBB_Add_User').$row['username'].' ('.$row['mail_address'].')';

      $query = "
        SELECT id, username, password, mail_address 
      	FROM ".USERS_TABLE."
      	WHERE BINARY username = BINARY '".$row['username']."'
      	LIMIT 1
      ;";
      $data = mysql_fetch_array(pwg_query($query));
      
      if (!empty($data))
        PunBB_Adduser($data['id'], $data['username'], $data['password'], $data['mail_address']);  
    }
  
    if ($msg_error_PWG2PunBB == '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Sync_PWG2PunBB').'<br/>'.l10n('LinkUser2PunBB_Sync_OK'));
    else
      $msg_error_PWG2PunBB = l10n('LinkUser2PunBB_Sync_PWG2PunBB').$msg_error_PWG2PunBB;
  
    
  
    $query = "
      SELECT id, username, email FROM ".PUNBB_USERS_TABLE."
      WHERE BINARY username <> BINARY '".$conf_nbc_LinkUser2PunBB[2]."'
      AND id not in (
        SELECT id_user_PunBB FROM ".LinkUser2PunBB_ID_TABLE."
      )
      AND BINARY username not in (
        SELECT username FROM ".USERS_TABLE."
      )
     	ORDER BY LOWER(username)
    ;";
    $result = pwg_query($query);
  
    while($row = mysql_fetch_array($result))
    {
      $msg_error_PunBB2PWG .= '<br/>'.l10n('LinkUser2PunBB_Error_PunBB2PWG').$row['username'].' ('.$row['email'].')';
  
      if ( !is_adviser() )
      {
        $msg_error_PunBB2PWG .= ' <a href="';
      
        $msg_error_PunBB2PWG .= add_url_params($page_LinkUser2PunBB_admin, array(
          'action' => 'del_user',
          'id' => $row['id'],
        ));
        $msg_error_PunBB2PWG .= '" title="'.l10n('LinkUser2PunBB_Del_User').$row['username'].'"';
        $msg_error_PunBB2PWG .= $conf_nbc_LinkUser2PunBB[4]=='false' ?  ' onclick="return confirm(\''.l10n('Are you sure?').'\');" ' : ' ';
        $msg_error_PunBB2PWG .= '><img src="'.NBC_LinkUser2PunBB_PATH.'/icon/user_delete.png" alt="'.l10n('LinkUser2PunBB_Del_User').$row['username'].'" /></a>';
      }
    }
  
    if ($msg_error_PunBB2PWG == '')
      array_push($page['infos'], l10n('LinkUser2PunBB_Sync_PunBB2PWG').'<br/>'.l10n('LinkUser2PunBB_Sync_OK'));
    else
      $msg_error_PunBB2PWG = l10n('LinkUser2PunBB_Sync_PunBB2PWG').$msg_error_PunBB2PWG;
  }
  else
    $errors[] = l10n('LinkUser2PunBB_Advise_Check_Dup');



  if ($msg_error_PWG_Dup <> '')
    $errors[] = $msg_error_PWG_Dup . ( ($msg_error_PunBB_Dup == '' and $msg_error_Link_Break == '' and $msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );
  
  if ($msg_error_PunBB_Dup <> '')
    $errors[] = $msg_error_PunBB_Dup . ( ($msg_error_Link_Break == '' and $msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Link_Break <> '')
    $errors[] = $msg_error_Link_Break . ( ($msg_error_Link_Bad == '' and $msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Link_Bad <> '')
    $errors[] = $msg_error_Link_Bad . ( ($msg_error_Synchro == '' and $msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_Synchro <> '')
    $errors[] = $msg_error_Synchro . ( ($msg_error_PWG2PunBB == '' and $msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_PWG2PunBB <> '')
    $errors[] = $msg_error_PWG2PunBB . ( ($msg_error_PunBB2PWG == '') ? '' : '<br/><br/>' );

  if ($msg_error_PunBB2PWG <> '')
    $errors[] = $msg_error_PunBB2PWG;
}
else if ( isset($_POST['Audit']))
{
  Audit_PWG_PunBB();
}






$conf_nbc_LinkUser2PunBB = isset($conf['nbc_LinkUser2PunBB']) ? explode(";" , $conf['nbc_LinkUser2PunBB']) : array();

$template->assign_vars(
  array(
    'PunBB_PREFIX'           => $conf_nbc_LinkUser2PunBB[0],
    'PunBB_ADMIN'            => $conf_nbc_LinkUser2PunBB[1],
    'PunBB_GUEST'            => $conf_nbc_LinkUser2PunBB[2],
    'PunBB_DEL_PT_TRUE'      => $conf_nbc_LinkUser2PunBB[3]=='true' ? 'checked="checked"' : '' ,
    'PunBB_DEL_PT_FALSE'     => $conf_nbc_LinkUser2PunBB[3]=='false' ? 'checked="checked"' : '' ,
    'PunBB_CONFIRM_TRUE'     => $conf_nbc_LinkUser2PunBB[4]=='true' ? 'checked="checked"' : '' ,
    'PunBB_CONFIRM_FALSE'    => $conf_nbc_LinkUser2PunBB[4]=='false' ? 'checked="checked"' : '' ,
    'PunBB_CONFIRM_ENABLE'   => $conf_nbc_LinkUser2PunBB[4]=='false' ? 'onclick="return confirm(\''.l10n('Are you sure?').'\');"' : '',
  )
);



// +-----------------------------------------------------------------------+
// |                             errors display                            |
// +-----------------------------------------------------------------------+
if ( isset ($errors) and count($errors) != 0)
{
  $template->assign_block_vars('errors',array());
  foreach ($errors as $error)
  {
    $template->assign_block_vars('errors.error', array('ERROR'=>$error));
  }
}



$template->set_filenames( array('plugin_admin_content' => NBC_LinkUser2PunBB_PATH.'admin/LinkUser2PunBB_admin.tpl') );

$template->assign_vars(  array(
  'U_HELP' => PHPWG_ROOT_PATH.'popuphelp.php?page=LinkUser2PunBB_admin',
));

$template->assign_var_from_handle( 'ADMIN_CONTENT', 'plugin_admin_content');
?>
